﻿using System;
using System.Threading.Tasks;
using Buddy.Coroutines;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Coroutines;
using Styx.WoWInternals.WoWObjects;

namespace Hades.spellManager {
    public class AsyncSpellManager {
        public static LocalPlayer Me {
            get { return StyxWoW.Me; }
        }
        public static string getSpellName (int spellId) {
            SpellFindResults results;
            if (SpellManager.FindSpell(spellId, out results)) {
                if (results.Override != null) 
                    return results.Override.Name;
                else
                    return results.Original.Name;
            } else {
                return null;
            }
        }
        public static async Task<bool> SpellCast(int spellId, WoWUnit target, bool gcd = false) {
            if (target == null) {
                return false;
            }

            if (!SpellManager.Cast(spellId, target)) {
                return false;
            }
            
            Logging.WriteQuiet(String.Format("Using: {0} on {1}", getSpellName(spellId), target));
           
            if (gcd) {
                await CommonCoroutines.SleepForLagDuration();
            }

            return true;
        }

        public static async Task<bool> SpellCast(int spellId, bool gcd = false) {
            return await SpellCast(spellId, Me.CurrentTarget, gcd);
        }

        public static async Task<bool> CastGroundSpell(int spellId, WoWUnit target, bool gcd = true) {
            if (target == null) {
                return false;
            }

            if (!SpellManager.Cast(spellId)) {
                return false;
            }

            Logging.WriteQuiet(String.Format("Fury: {0} Cast: {1} on {2}", Me.CurrentFury, spellId, target));

            if (!await Coroutine.Wait(1000, () => Me.CurrentPendingCursorSpell != null)) {
                Logging.WriteDiagnostic("No Cursor Detected");
                return false;
            }

            SpellManager.ClickRemoteLocation(target.Location);

            if (gcd) {
                await CommonCoroutines.SleepForLagDuration();
            }
            return true;
        }
    }
}