﻿using System;
using System.Threading.Tasks;
using CommonBehaviors.Actions;
using Styx;
using Styx.CommonBot;
using Styx.CommonBot.Routines;
using Styx.TreeSharp;
using Styx.WoWInternals.WoWObjects;
using System.Diagnostics;
using Styx.Common;
using System.Windows.Media;
using Hades.spellManager;
using Hades.spellsAndAuras;
using Hades.units;

namespace Hades
{
    class Hades : CombatRoutine
    {
        private static uint CurrentFury => StyxWoW.Me.GetPowerInfo(WoWPowerType.Fury).Current;
        private static LocalPlayer Me
        {
            get
            {
                return StyxWoW.Me;
            }
        }
        public override WoWClass Class
        {
            get
            {
                if (Me.Specialization == WoWSpec.DemonHunterHavoc || Me.Specialization == WoWSpec.DemonHunterVengeance)
                    return WoWClass.DemonHunter;
                else
                    return WoWClass.None;
            }
        }
        public override string Name
        {
            get
            {
                return "Hades Demon Hunter Combat Routine - By Exocet";
            }
        }
        public override void Initialize()
        {

            Logging.Write(Colors.Tomato, "Hello {0}!", Me.SafeName);
            Logging.Write(Colors.White, "");
            Logging.Write(Colors.Tomato, "For Best performance please use: Enyo");
            Logging.Write(Colors.White, "");
            Logging.Write(Colors.Tomato, "-- Hades --");
            Logging.Write(Colors.Tomato, "-- Version: v0.1 --");
            Logging.Write(Colors.Tomato, "-- by Exocet --");
            Logging.Write(Colors.Tomato, "-- Demon Hunter CombatRoutine --");

        }
        public override void ShutDown()
        {

        }
        public override Composite CombatBehavior
        {
            get
            {
                if (Me.Specialization == WoWSpec.DemonHunterHavoc)
                    return new ActionRunCoroutine(ctx => HavocCoroutine());
                else
                    return new ActionRunCoroutine(ctx => VengenceCoroutine());
            }
        }
        private static Stopwatch _enemyScanner = new Stopwatch();

        private static TimeSpan GetSpellCooldown(int spell)
        {
            SpellFindResults results;
            if (SpellManager.FindSpell(spell, out results))
            {
                if (results.Override != null)
                    return results.Override.CooldownTimeLeft;
                return results.Original.CooldownTimeLeft;
            }
            return TimeSpan.MaxValue;
        }

        private static int enemyCount;
        private static async Task<bool> HavocCoroutine()
        {

            if (_enemyScanner.ElapsedMilliseconds >= 500)
            {
                enemyCount = Units.SurroundingEnemiesInRange().Count;
                _enemyScanner.Restart();

            }
            else if (_enemyScanner.IsRunning == false)
            {
                _enemyScanner.Start();
                Logging.WriteQuiet(String.Format("Scanning Enemies"));
            }

            if (CurrentFury < 40 && Me.CurrentTarget.IsWithinMeleeRange && SpellManager.CanCast(SpellsAndAuras.DemonsBite))
            {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.DemonsBite))
                {
                    return true;
                }
            }

            if (CurrentFury >= 40 && Me.CurrentTarget.IsWithinMeleeRange && SpellManager.CanCast(SpellsAndAuras.ChaosStrike))
            {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.ChaosStrike))
                {
                    return true;
                }
            }

            if (enemyCount >= 3 && Me.CurrentTarget.IsWithinMeleeRange && SpellManager.HasSpell(SpellsAndAuras.BladeDance))
            {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.BladeDance))
                {
                    return true;
                }
            }

            if (CurrentFury >= 50 && enemyCount >= 2 && SpellManager.CanCast(SpellsAndAuras.EyeBeam))
            {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.EyeBeam, false))
                {
                    return true;
                }

            }

            if (enemyCount >= 1 && Me.CurrentTarget.IsWithinMeleeRange && SpellManager.CanCast(SpellsAndAuras.EyeBeam))
            {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.ThrowGlaive, false))
                {
                    return true;
                }
            }

            return true;
        }





private static async Task<bool> VengenceCoroutine()
        {

            if (_enemyScanner.ElapsedMilliseconds >= 500)
            {
                enemyCount = Units.SurroundingEnemiesInRange().Count;
                _enemyScanner.Restart();

            }
            else if (_enemyScanner.IsRunning == false)
            {
                _enemyScanner.Start();
                Logging.WriteQuiet(String.Format("Scanning Enemies"));
            }

            if (CurrentFury < 40 && Me.CurrentTarget.IsWithinMeleeRange && SpellManager.CanCast(SpellsAndAuras.DemonsBite))
            {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.DemonsBite))
                {
                    return true;
                }
            }

            if (CurrentFury >= 40 && Me.CurrentTarget.IsWithinMeleeRange && SpellManager.CanCast(SpellsAndAuras.ChaosStrike))
            {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.ChaosStrike))
                {
                    return true;
                }
            }

            if (enemyCount >= 3 && Me.CurrentTarget.IsWithinMeleeRange  && SpellManager.HasSpell(SpellsAndAuras.BladeDance))
            {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.BladeDance))
                {
                    return true;
                }
            }

            if (CurrentFury >= 50 && enemyCount >= 2 && SpellManager.CanCast(SpellsAndAuras.EyeBeam))
            {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.EyeBeam, false))
                {
                    return true;
                }

            }

            if (enemyCount >= 1 && Me.CurrentTarget.IsWithinMeleeRange && SpellManager.CanCast(SpellsAndAuras.EyeBeam))
            {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.ThrowGlaive, false))
                {
                    return true;
                }
            }

            return true;
        }
    }
}