﻿using Styx;
using Styx.Common;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using Hades.spellsAndAuras;

namespace Hades.units {
   public static class Units {
        private static LocalPlayer Me {
            get {
                return StyxWoW.Me;
            }
        }
        public static bool auraExists (this WoWUnit Unit, int auraID, bool isMyAura = false) {
            try {
                if (Unit == null || !Unit.IsValid)
                    return false;
                WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
                return Aura != null;
            } catch (Exception xException) {
                Logging.WriteDiagnostic("Exception in auraExists(): ", xException);
                return false;
            }
        }
        public static uint auraStacks (this WoWUnit Unit, int auraID, bool isMyAura = false) {
            try {
                if (Unit == null || !Unit.IsValid)
                    return 0;
                WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
                return Aura != null ? Aura.StackCount : 0;
            } catch (Exception xException) {
                Logging.WriteDiagnostic("Exception in auraStacks(): ", xException);
            }
            return 0;
        }
        public static double auraTimeLeft (this WoWUnit Unit, int auraID, bool isMyAura = false) {
            try {
                if (Unit == null || !Unit.IsValid)
                    return 0;
                WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
                return Aura != null ? Aura.TimeLeft.TotalMilliseconds : 0;
            } catch (Exception xException) {
                Logging.WriteDiagnostic("Exception in auraTimeLeft(): ", xException);
                return 9999;
            }
        }
        public static List<WoWUnit> SurroundingEnemiesInRange () {
            return ObjectManager.GetObjectsOfTypeFast<WoWUnit>().Where(o =>
                        o.Attackable &&
                        o.IsWithinMeleeRangeOf(Me) &&
                        o.IsValid &&
                        o.IsAlive &&
                        !o.IsFriendly &&
                        !o.IsNonCombatPet &&
                        !o.IsCritter
                        )
                        .OrderBy(o => o.Distance)
                        .ToList();
        }
        public static List<WoWUnit> SurroundingEnemiesWithRend () {
            return ObjectManager.GetObjectsOfTypeFast<WoWUnit>().Where(o =>
                        o.Attackable &&
                        o.Distance <= 30 &&
                      
                        o.IsValid &&
                        o.IsAlive &&
                        !o.IsFriendly &&
                        !o.IsNonCombatPet &&
                        !o.IsCritter
                        )
                        .OrderBy(o => o.Distance)
                        .ToList();
        }
    }
}
